(* W01 *)
(* E01 *)
(* W02 *) 
type 'a t = 'a list
(* hd : 'a list -> 'a *)
let hd = function x::_ -> x
                | _    -> failwith "empty list"
(* tl : 'a list -> 'a list *)
let tl = function _::xs -> xs
                | _     -> failwith "empty list"
(* append : 'a list -> 'a list -> 'a list *)
let rec (@) xs ys = match xs with []     -> ys
                                 | x::xs -> x::(xs @ ys)
(* replicate : int -> 'a -> 'a list *)
let rec replicate n x = 
 if n < 1 then [] else x::replicate (n-1) x
(* take : int -> 'a list -> 'a list *)
let rec take n xs = if n < 1 then [] else match xs with
 | []    -> []
 | x::xs -> x::take (n-1) xs
(* drop : int -> 'a list -> 'a list *)
let rec drop n xs = if n < 1 then xs else match xs with
 | []    -> []
 | _::xs -> drop (n-1) xs
(* split_at : int -> 'a list -> ('a list * 'a list *)
let split_at n xs = (take n xs,drop n xs)
(* map : ('a -> 'b) -> 'a list -> 'b list *)
let rec map f = function []    -> []
                       | x::xs -> f x::map f xs
(* foldr : ('a -> 'b -> 'b) -> 'b -> 'a list -> 'b *)
let rec foldr f b = function []     -> b
                           | x::xs -> f x (foldr f b xs)
(* foldl : ('a -> 'b -> 'a) -> 'a -> 'b list -> 'a *)
let rec foldl f b = function []    -> b
                           | x::xs -> foldl f (f b x) xs
(* filter : ('a -> bool) -> 'a list -> 'a list *)
let rec filter p = function
 | []    -> []
 | x::xs -> if p x then x::filter p xs else filter p xs
